#ifndef __AVI_STREAM_INCLUDED
#define __AVI_STREAM_INCLUDED

#include <windows.h>
#include <vfw.h>

struct TAVI_Stream {
	PAVISTREAM p_avi_stream;
	PGETFRAME p_avi_frame;
	

	float f_frames_per_second;
	float f_length; // seconds
	int n_length; // frames
	int n_width;
	int n_height;
	int n_color_planes; // 1 to 4 in practise, curently works for 3 only (RGB)
};

TAVI_Stream *p_AVI_Load(const char *p_s_avi_file, int b_rgba); // set b_rgba if you want 4 channels (you can get any supported number of channels, but you can make it likely faster)
void AVI_Free(TAVI_Stream *p_avi); // free(p_avi) as well

int AVI_GetFrame_t(TAVI_Stream *p_avi, float f_time, unsigned char *p_image, int n_channels, int n_bits_channel);
int AVI_GetFrame_f(TAVI_Stream *p_avi, long n_frame, unsigned char *p_image, int n_channels, int n_bits_channel);
// currently support for 3 or 4 channels, 8 bits per pixel - otherwise fails

#endif //__AVI_STREAM_INCLUDED
