/*
								+---------------------------------+
								|                                 |
								|   ***   Material system   ***   |
								|                                 |
								|  Copyright   -tHE SWINe- 2006  |
								|                                 |
								|          MaterialSys.h          |
								|                                 |
								+---------------------------------+
*/

#ifndef __MATERIAL_SYSTEM_INCLUDED
#define __MATERIAL_SYSTEM_INCLUDED

/*

  shader pool
	- shaders

  material
	- material properties
	- pass
      - OpenGL state
      - shader name
	  - parameter values
		- set shader parameters by shader parameter name
	  - texture names
		- bind to texture units by shader texture unit name
		- texture type validity checking using sampler types (1D, 2D, ...)

  i.e. material pass needs to (physically) have:
	- OpenGL state table
	- pointer to shader
	- table with parameter references
	  - swizzle sequence
	  - pointer to parameter reference (either vector or matrix)
	  - parameter dirty flag? (parameters are written in manner specify once, use many times)
	    maybe remember number of materials, sharing a single shader, if 1 then there's no need
		to change most params. otherwise it might be useful to mark equal parameters so we
		know which ones are left to re-specify
	  - source value (parameter type depends on it)

  image-processing filter
    - kind of material, different way of supplying by textures
	- source texture(s)
	- destination texture(s)
	- temporal textures, ping-pong textures
	- todo - improve this concept

*/

#endif //__MATERIAL_SYSTEM_INCLUDED
